-- Dump of fbLFSR
-- Généré le Fri, 23 Nov 2012 17:04:35 GMT
-- par http://127.0.0.1/~yg/index.dev.html
--    yasep/ASM/YASMed.js version 2012/11/22-dev
Library work;
    use work.yasep_definitions.all;
    use work.yasep_utils.all;
Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;

entity SynchRam16 is
 port(
  clk, reset, en: in std_logic := '0';
  NPC: in SLVAI;
  RAM_out: out SLV16);
end SynchRam16;

architecture fbLFSR of SynchRam16 is
  signal latched_addr : SLVAI := (SLVAI'range=>'0');
  type RAM_array_type is array(0 to 23) of SLV16;
  constant RAM_array : RAM_array_type := (
 -- ; fbLFSR : remplit l'écran avec
 -- ; une couleur pseudo-aléatoire
 -- .name fbLFSR
 -- .profile YASEP32
 -- ; Affectation des registres :
 -- ;   R1 : LFSR (couleur)
 -- ;   R2 : polynome
 -- ;   R3 : compteur
 -- ;   A1 : loop
 -- ;   A2 : écran (registre d'Adresse)
 --        ; associé à D2 (registre de Donnée)
 "0011000100001001", "0000000000000000", -- mov 65536 R3
 -- ; adresse du framebuffer:
 "1101001000001001", "0000000000000000", -- mov 20000h A2
 "0001000000001001", "1010000000000000", -- mov   A000h R1
 "0001000110001001", "0000000011111111", -- movh  FFh   R1 ; #00A0FF : bleu ciel
 -- ; initialise le polynôme du LFSR:
 "0010000000001001", "0001110110110111", -- mov  1DB7h R2 ; LSB
 "0010001010001001", "0000010011000001", -- movh 04C1h R2 ; MSB
 "0100000000010111", "00001111000---1-", -- add 4 PC A1
 -- ;;;;; début de la boucle ;;;;;
 --   ; génère un bit pseudo-aléatoire :
 "0001000100010100", --   ADD R1 R1 ; décale le registre et
 --             ; met le bit de poids fort
 --             ; dans la retenue
 --   ; si la retenue est à 1, alors on xor
 "0010000111010011", "00000001100---0-", --   xor R2 R1 CARRY
 --   ; écrit la couleur dans le framebuffer
 "0001110000001000", --   mov R1 D2
 "0100110100010110", --   add 4 A2
 --   ; décrémente le compteur
 "1111001100010110", --   add -1 R3
 --   ; on remet A1 dans PC si R3 n'est pas égal à 0
 "1111000000001011", "00110000001---0-", --   mov A1 PC NZ R3
 -- ;;;;;; fin de la boucle ;;;;;;
 "--------00000100", -- HALT
 "1111111111111111" );

begin

  assert YASEP_SIZE=32 report "YASEP_SIZE is not 32" severity warning;

  process(clk, en)
  begin
    if rising_edge(clk) and en='0' then
      latched_addr <= NPC;
    end if;
  end process;

  process(latched_addr ,reset)
    variable adr: integer;
  begin
    if reset/='1' then
      RAM_out <= (RAM_out'range=>'0');
    else
      adr := safe_to_integer(latched_addr);
      if adr < 0 or adr >= RAM_array'length then
        report " Accessing instruction beyond limit at " & integer'image(adr);
        RAM_out <= (RAM_out'range=>'1');
      else
        RAM_out <= RAM_array(adr);
      end if;
    end if;
  end process;
end fbLFSR;
